const Docker = require("dockerode");
const docker = new Docker();

const start = async (image, res) => {
  const port = Math.floor(Math.random() * (55000 - 50000) + 50000).toString();
  docker.createContainer(
    {
      Image: image,
      AttachStdin: false,
      AttachStdout: true,
      AttachStderr: true,
      HostConfig: {
        // AutoRemove: true,
        ShmSize: 2000000000,
        PortBindings: {
          "5900/tcp": [
            {
              HostIp: "",
              HostPort: port,
            },
          ],
        },
      },
      Env: [
        `USERNAME=${req.body.username || "pardus"}`,
        `PASSWORD=${req.body.password || "pardus"}`,
        `SUDO=${req.body.sudo || true}`,
        `SOUND=${req.body.sound || true}`,
        `SPICE_PASSWORD=${req.body.spice_password || false}`,
      ],
    },
    function (err, container) {
      container.start();
      res.json({ id: container.id, port: port });
    }
  );
};

module.exports = start;
